#ifndef ITERATORS
#define ITERATORS

// standard libraries
#include <strstream.h>
#include <String.h>

template <class T>
String convert_to_str(T i, int max_length = 20)
{
  char buffer[20];
  ostrstream nmb(buffer, max_length);
  nmb << i << '\0';
  return String(buffer);
}
template < class value_type >
value_type minimum( value_type a, value_type b )
{
    return a < b ? a : b;
}

template < class Iterator, class DA >
Iterator minimum( Iterator const& begin, Iterator const& end, DA da )
{
    return minimum(begin, end, da, less<typename DA::value_type>());
}

template < class Iterator, class DA, class Compare >
Iterator minimum( Iterator const& begin,
                  Iterator const& end,
                  DA da,
                  Compare const& cmp )
{
    typename DA::value_type current, min = get(da, begin);
    Iterator min_it = begin;
    for (Iterator current_it = begin; current_it != end; ++current_it)
    {
        current = get(da, current_it);
        if (cmp(current, min))
        {
            min = current;
            min_it = current_it;
        }
    }
    return min_it;
}


template < class value_type >
value_type maximum( value_type a, value_type b )
{
    return a > b ? a : b;
}

template < class Iterator, class DA >
Iterator maximum( Iterator const& begin, Iterator const& end, DA da )
{
    return maximum(begin, end, da, less<typename DA::value_type>());
}

template < class Iterator, class DA, class Compare >
Iterator maximum( Iterator const& begin,
                  Iterator const& end,
                  DA da,
                  Compare const& cmp )
{
    typename DA::value_type current, max = get(da, begin);
    Iterator max_it = begin;
    for (Iterator current_it = begin; current_it != end; ++current_it)
    {
        if ( cmp(max, (current = get(da, current_it))) )
        {
            max = current;
            max_it = current_it;
        }
    }
    return max_it;
}

#endif
