
#ifndef MAPLAB_RANDOM_H
#define MAPLAB_RANDOM_H
#include <stdlib.h>

class MAPLAB_Random
{
public:
  // types
  typedef  unsigned short  Seed[3];                   // 48 Bits

  // creation
  MAPLAB_Random( );
  MAPLAB_Random( Seed seed);
  MAPLAB_Random( long init);

  // operations
  // bool    get_bool  ( );
  int     get_int   ( int lower, int upper);
  double  get_double( double lower = 0.0, double upper = 1.0);

  int     operator () ( int upper);

  // seed functions
  void       save_seed( Seed      & seed) const;
  void    restore_seed( Seed const& seed);

  // equality test
//      bool  operator == ( MAPLAB_Random const& rnd) const;

    private:
      // data members
      unsigned short  _seed[3];                           // 48 Bits
    };
/*
inline
bool
MAPLAB_Random::
get_bool( )
{
  return (bool) (erand48( _seed) >= 0.5);
}
*/
inline
int
MAPLAB_Random::
get_int( int lower, int upper)
{
  return( lower + ( (int) ( (upper-lower) * erand48( _seed))) );
}

inline
double
MAPLAB_Random::
get_double( double lower, double upper)
{
  return( lower + ( upper-lower) * erand48( _seed));
}

inline
int
MAPLAB_Random::
operator () ( int upper)
{
  return( get_int( 0, upper));
}
/*
inline
bool
MAPLAB_Random::
operator == ( MAPLAB_Random const& rnd) const
{
  return( ( bool)
  ( _seed[ 0] == rnd._seed[ 0]) &&
    ( _seed[ 1] == rnd._seed[ 1]) &&
    ( _seed[ 2] == rnd._seed[ 2]) );
}
*/

#endif // MAPLAB_RANDOM_H
