#include <fstream.h>
#include <MAPLAB/error_handling/assertion.h>
#include <stdlib.h>             // needed by system()
#include <MAPLAB/random.h>
#include <MAPLAB/basic.h>


#if ( string_to_width_NO_CHECKING ||  STRING_TO_WIDTH_NO_CHECKING || NDEBUG)
#define string_to_width_assert(cond)
#else
#include <iostream.h>
#define string_to_width_assert(cond) \
    ((cond) ? (void)0 : assertion_error( cerr, #cond, __LINE__, __FILE__))
#endif

template <class Str, class Size,
          class StringIt, class WidthIt,
          class StringDA, class WidthDA>
void string_to_width(StringIt strbegin, StringIt strend,
                     Str psinterpreter,
                     Str fontname,
                     Size fontsize,
                     WidthIt wbegin,
                     StringDA strda,
                     WidthDA wda
)
{
  // open temporary file
  Str basename("tmp" + convert_to_str(MAPLAB_Random().get_double()));
  Str psfilename(basename + ".ps");
  ofstream psfile(psfilename);
  string_to_width_assert(psfile);
  
  // print postscript header
  psfile << "%!PS-Adobe-2.0 EPSF-2.0\n/" << fontname << " findfont\n"
         << "dup length dict begin {1 index /FID ne {def} {pop pop}"
         << " ifelse}\nforall /Encoding ISOLatin1Encoding def currentdict"
         << " end\n/ISOLatin1 exch definefont\n"
         << fontsize << " scalefont setfont\n/str 20 string def\n"
         << "/sp {stringwidth pop str cvs print ( ) print} def\n";
  
  // print data
  for (; strbegin != strend; strbegin++)
    psfile << '(' << get(strda, strbegin) << ") sp" << endl;
  
  // print footer
  psfile << "flush" << endl << "% EOF" << endl;
  psfile.close();
  Str checkcommand("tcsh -c \"which " + psinterpreter +
                   " | fgrep 'Command not found'\"");
  // (can also pipe to /dev/null to avoid error message)
  string_to_width_assert(system((const char*) checkcommand) != 0);
  Str datafilename(basename + ".data");
  Str command(psinterpreter + " -q -dNODISPLAY -- " + psfilename +
              " > " + datafilename);
  string_to_width_assert(system((const char*) command) == 0);
  ifstream datafile(datafilename);
  string_to_width_assert(datafile);
  typename WidthDA::value_type width;
  char dummy;
  while (datafile)
  {
    datafile >> width >> dummy;
    if (dummy != '\n') datafile.putback(dummy);
    Set(wda, wbegin++, width);
  }
  Str rmcommand("\\rm -f " + psfilename + " " + datafilename);
  string_to_width_assert(system((const char*) rmcommand) == 0);
}
