#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>
#include <String.h>


const int MAX = 1024;

main(int argc, char *argv[])
{
  if (argc < 3)
  {
    cout << "usage: file1 {file2 ... fileN}" << " destination_directory"
    << endl;
    exit(-1);
  }

  ofstream gplot_data("tmp.gnu");
  String tmp_file("tmp.tex");

  gplot_data << "set nokey" << endl
             << "set xrange [0:3250]" << endl
             << "plot '" << argv[1]  << "' w l 1, '" << argv[1]
             << "' w errorbars 1" << endl;

  for (int i = 2; i < (argc-1); i++)
    gplot_data << "replot '" << argv[i]  << "' w linesp " << (i) << " "
               << (i+2) << ", '" << argv[i] << "'  w errorbars " << (i)
               << endl;

  gplot_data << "set term latex" << endl
             << "set output '" << tmp_file << "'" << endl
             << "replot" << endl;

  gplot_data.close();

  system("gnuplot 'tmp.gnu'");

  String out_file(argv[1]);
  out_file = out_file.after('/', -1);
  out_file = out_file.before('_') + String(".tex");

  ifstream gplot_data_in("tmp.tex");
  ofstream gplot_data_out(out_file);

  gplot_data_out << "\\documentclass[twoside,12pt]{article}" << endl
                 << "\\usepackage{epsfig}" << endl
                 << "\\usepackage{latexsym}" << endl
                 << "\\pagestyle{empty}" << endl
                 << "\\begin{document}" << endl << endl;

  char buff[MAX], new_line_char;

  while (gplot_data_in.get(buff, MAX))
  {
    String line(buff);
    if (line.contains('_'))
    {
      String file_name = line.after("'");
      file_name = file_name.before("'");
      String repl(file_name.after('_'));
      repl = repl.before('.');
      line.gsub(file_name, repl);
    }
    gplot_data_in.get(new_line_char);
    gplot_data_out << line << endl;
  }
  gplot_data_out << "\\end{document}" << endl;
  gplot_data_out.close();

  String comm("latex ");
  comm += out_file;
  system(comm.chars());
  // comm = String("mv ") + out_file + String(" ") + String(argv[argc-1]);
  // system(comm.chars());
  out_file = out_file.before('.', -1);
  comm = String("dvips -o ") + out_file + String(".ps ") + out_file +
    String(".dvi ");
  system(comm.chars());
  String destination(argv[argc-1]);
  if (destination != ".")
  {
    comm = String("mv ") + out_file + String(".ps ") + String(argv[argc-1]);
    system(comm.chars());
  }
  system("rm *.log");
  system("rm *.aux");
  system("rm *.gnu");
  system("mv *.tex tex");
  system("mv *.dvi dvi");
}
