
#include <MAPLAB/random.h>
#include <sys/time.h>

MAPLAB_Random::
MAPLAB_Random( )
{
    // get system's microseconds
    timeval tv;
    gettimeofday( &tv, NULL);
    unsigned long  ms = tv.tv_sec*1000000+tv.tv_usec;

    // initialize random numbers generator
    _seed[ 0] = _seed[ 2] = (unsigned short) (ms >> 16);
    _seed[ 1] = ( unsigned short) (ms & 65535);
}

MAPLAB_Random::
MAPLAB_Random( Seed seed)
{
    // initialize random numbers generator
    _seed[ 0] = seed[ 0];
    _seed[ 1] = seed[ 1];
    _seed[ 2] = seed[ 2];
}

MAPLAB_Random::
MAPLAB_Random( long init)
{
    // initialize random numbers generator
    _seed[ 0] = _seed[ 2] = (unsigned short) (init >> 16);
    _seed[ 1] = (unsigned short) (init & 65535);
}



// seed functions
void
MAPLAB_Random::
save_seed( Seed& seed) const
{
    seed[ 0] = _seed[ 0];
    seed[ 1] = _seed[ 1];
    seed[ 2] = _seed[ 2];
}

void
MAPLAB_Random::
restore_seed( Seed const& seed)
{
    _seed[ 0] = seed[ 0];
    _seed[ 1] = seed[ 1];
    _seed[ 2] = seed[ 2];
}
